# CCE Frontend

Author: XLAB d.o.o.

---

## Project setup

### Install dependencies
```
npm install
```

### Compiles and hot-reloads for development
```
npm run serve
```

### Compiles and minifies for production
```
npm run build
```

### Lints and fixes files
```
npm run lint
```

## Docker

### Docker build
```
docker build -t registry-gitlab.xlab.si/medina/cce-frontend .
```

### Docker run
```
docker run -p 8081:80 registry-gitlab.xlab.si/medina/cce-frontend:latest
```

## Versioning

Before pushing to master check if version needs to be updated  in [package.json](package.json#L3).
This version is also used for tagging docker image at CI.

## Setting API URL

You can set the API URL using the `CCE_API_URL` environment variable. 
By default (if unset) the URL used is MEDINA k8s dev deploy: https://cce-api-dev.k8s.medina.esilab.org

## Local development environment

To run CCE frontend locally and call CCE API in MEDINA DEV environment use following configuration:

**.env.development**
```
VUE_APP_API="https://cce-api-dev.k8s.medina.esilab.org/"
VUE_APP_KEYCLOAK_URL="https://catalogue-keycloak-dev.k8s.medina.esilab.org/auth"
```

**vue.config.js**
```
module.exports = {
  devServer: {
    historyApiFallback: true,
    port: 443,
    host: 'cce-dev.k8s.medina.esilab.org',
    https: true
  }
}
```

**/etc/hosts**
```
127.0.0.1 cce-dev.k8s.medina.esilab.org
```

### And run in console
```
sudo node_modules/.bin/vue-cli-service serve
```
