/*
 * Copyright 2020-2023 XLAB d.o.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

export const collapseExpandTree = {
  methods: {
    collapseRecursively(node) {
      if (!node.children) {
        return;
      }

      node.children.forEach((i) => {
        this.collapseRecursively(i);
      });

      node._children = node.children;
      node.children = null;
      node._collapsed = true;
    },

    collapseAllFromLevel(node, level) {
      if (level <= 0) {
        this.collapseRecursively(node);
      } else {
        node.children?.forEach((i) => {
          this.collapseAllFromLevel(i, level - 1);
        });
      }
    },

    expandRecursively(node) {
      if (node._children) {
        node.children = node._children;
        node._children = null;
        node._collapsed = false;
      }
      node.children?.forEach((n) => {
        this.expandRecursively(n);
      });
    },
  },
};
