/*
 * Copyright 2020-2023 XLAB d.o.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import { AggregatedResultService } from "@/services/AggregatedResultService";

export default {
  state: {
    complianceReport: undefined,
  },
  mutations: {
    SAVE_COMPLIANCE_REPORT(state, complianceReport) {
      state.complianceReport = complianceReport;
    },
  },
  getters: {
    complianceReport: (state) => state.complianceReport,
  },
  actions: {
    async getComplianceReport({ commit, getters }) {
      if (1 > 4 && getters.complianceReport) {
        return getters.complianceReport;
      }
      await AggregatedResultService.getComplianceReport()
        .then((response) => {
          commit("SAVE_COMPLIANCE_REPORT", response.data);
        })
        .catch((err) => {
          console.error("Error getting compliance report: " + err);
        });
      return getters.complianceReport;
    },
  },
};
